	.overlay clrColor
	.origin pixgen

clearTypeColor:	
	ld_s	dma__cmd+0,tmp_r12		; Have to set the DIRECT bit
	nop
	or	#(1<<27),tmp_r12
	st_s	tmp_r12,dma__cmd+0

	ld_s	bgColor,tmp_r12
	nop	
	st_s	tmp_r12,dma__cmd+16		; Store the color in the direct data

nextBlockVert:
	cmp	#8,hRemaining_r4
	jmp	ge,gotHeight
	mv_s	#8,hCur_r11			; Assume 8 pixels
	nop
	copy	hRemaining_r4,hCur_r11		; Nope, was not 8, clamp
gotHeight:

	ld_s	xclip,tmp_r12
	nop
	lsr	#16,tmp_r12,wRemaining_r6
	and	#$FFFF,tmp_r12
	sub	tmp_r12,wRemaining_r6		; Get width in pixels
	add	#1,wRemaining_r6

	ld_s	xclip,xCur_r8
	nop
	and	#$FFFF,xCur_r8			; Initialize current X coord

nextBlockHoriz:
	cmp	#8,wRemaining_r6		; Check if rest of width is less than 8
	jmp	ge,gotWidth
	mv_s	#8,wCur_r10
	nop
	copy	wRemaining_r6,wCur_r10
gotWidth:

	lsl	#16,wCur_r10,tmp_r12		; Construct the X pos and W
	add	xCur_r8,tmp_r12
	st_s	tmp_r12,dma__cmd+8

	lsl	#16,hCur_r11,tmp_r12		; Construct the Y pos and H
	add	yCur_r9,tmp_r12
	st_s	tmp_r12,dma__cmd+12

	st_s	#dma__cmd,mdmacptr		; Start the DMA
	
{	jsr	mdma_wait,nop
	DMAWAITCNT_ITEM 8
}

	add	wCur_r10,xCur_r8
	sub	wCur_r10,wRemaining_r6
	jmp	gt,nextBlockHoriz,nop
	
	add	hCur_r11,yCur_r9
	sub	hCur_r11,hRemaining_r4
	jmp	gt,nextBlockVert,nop

	jmp	nextSlice
	nop
	nop
