;;; ================================================================================================
;;; 
;;; Yaroze-style renderer
;;;
;;; Transparency: NO
;;; Translucency: NO
;;; Brightness:   NO
;;;
;;; Straight blit.
;;;
;;; Num ticks:	
;;;   All pixels - 2
;;;
;;; ================================================================================================

	.overlay pixyar0
	.origin pixgen

.ifndef PERFMON_ENABLE
	PERFMON_ENABLE	= 0
.endif

	pixSrc1_r0	= r0
	pixSrc2_r1	= r1
	destPtr_r4	= r4
	
pixelTypeYar0:
	
.if (PERFMON_ENABLE == 1)
	ld_s	perfmonPixels+0,r0
	nop
	add	dma_len,r0
	st_s	r0,perfmonPixels+0
.endif
	
	st_s	dma_len,rc0			; number of pixels to iterate over
{	ld_s	(uv),pixSrc1_r0			; read first pixel
	copy	buffer_offset,destPtr_r4	; get destination buffer pointer
	dec	rc0				; pre-decrement
	addr	tosource[0],ru			; advance to next pixel...
}
{	addr	tosource[2],rv			; ...continue advancing to next pixel
	add	#dest_buffer,destPtr_r4		; account for double buffer
}

`next_pixel:
{	bra	c0eq,out			; are we done?
	ld_s	(uv),pixSrc2_r1			; get next pixel
	dec	rc0				; one more pixel done
	addr	tosource[0],ru			; advance to next pixel...
}
{	addr	tosource[2],rv			; ...continue advancing to next pixel
	bra	c0ne,`next_pixel		; branch back if not done
	st_s	pixSrc1_r0,(destPtr_r4)		; store pixel in dest buffer
	add	#4,destPtr_r4			; advance destination buffer pointer
}
{	bra	out				; fell through, must be finished
	ld_s	(uv),pixSrc1_r0			; get next pixel
	dec	rc0				; one more pixel done
	addr	tosource[0],ru			; advance to next pixel...
}
{	addr	tosource[2],rv			; ...continue advancing to next pixel
	st_s	pixSrc2_r1,(destPtr_r4)		; store pixel in dest buffer
	add	#4,destPtr_r4			; advance destination buffer pointer
}
	nop

endPixelTypeYar0:
