#ifndef _LIBSPRITE_MACROS_
#define _LIBSPRITE_MACROS_

#define SPRCreateSpriteMac(retVal, _info, _x, _y, _w, _h)\
{\
  SPRITE *newspr;\
\
  newspr = (SPRITE*) QGetHead(&freeSprites);\
\
  if (newspr) {\
    newspr = (SPRITE *) (((void*) newspr) - 4); /* subtract 4 for the "parent" pointer */\
    /* memset(newspr,0,sizeof(SPRITE)); */\
    newspr->src_x      = _x<<16;\
    newspr->src_y      = _y<<16;\
    newspr->w          = _w;\
    newspr->h          = _h;\
    newspr->source     = _info->img;\
    newspr->dmaflags   = _info->dmaflags;\
    newspr->tint       = 0x40404000;\
    newspr->transColor = 0x10808000;\
    newspr->q.priority = 0;\
    newspr->parent     = &usedSprites;\
\
    QAdd(&usedSprites, &newspr->q, -1);\
    newspr->parent = &usedSprites;\
\
    retVal = newspr;\
  }\
\
  printf("LIBSPRITE ERROR: Ran out of sprites?\n");\
  countAllElements(0, NULL, NULL);\
  countAllElements(1, "SPRCreateSprite", " end2");\
  countAllElements(2, NULL, NULL);\
\
  retVal = 0;\
}

#endif
