;;; ================================================================================================
;;; 
;;; Draws sprites without rotation or scaling.  This allows direct read/write from source to
;;; destination (barring any RGB and translucency).
;;; 
;;; ================================================================================================

	.overlay spFTpS
	.origin pixgen
	
	.include "sp_def.i"

pixelTypeYarFastTp_Small:
	push	v2
	push	v3
	push	v4
	push	v5
	push	v6
	push	v7

	;; Set up the DMA as much as we can
	ld_s	fbDMAFlags,r0			; get dma flags
	ld_s	fbAddress,r1			; get frame buffer pointer
	ld_s	spr_tint,r2			; get line color
	or	#(1<<27),r0			; set direct bit
	st_s	r0,dma__cmd+0
	st_s	r1,dma__cmd+4
	and	#$FFFFFF00,r2			; mask out hint bits
	st_s	r2,dma__cmd+16

`done:
	jsr	mdma_wait,nop
	
	pop	v7
	pop	v6
	pop	v5
	pop	v4
	pop	v3
	pop	v2
	
	pop	v0,rz
	nop
	jmp	spriteDoneOuter,nop

pixelTypeYarFastTp_Small_end:
