.ifndef _SP_DEF_
	_SP_DEF_	= 1

//	pixel = v0
//	pixel2 = v1
//	pixel3 = v2
//	pixel4 = v3
//	pixel5 = v4
//	xi = tosource[0]
//	yi = tosource[2]
;	x = r20
;	_y = r21
	_dma_dbase = r22
	_mix = r23

.ifndef PERFMON_ENABLE
	PERFMON_ENABLE	= 0
.endif

	;; == INPUTS ========
	inpBufPtr_r16	= r16
	inpZero_r17	= r17
	inp1dot24_r19	= r19
	;; ==================

	;; == TYPE 0 ========
	pixSrc1_r0	= r0
	pixSrc2_r1	= r1
	;; ==================

	;; == TYPE 1 ========
	mask_r0		= r0
	srcPixel1_r1	= r1
	srcPixel2_r2	= r2
	const1_r5	= r5
	transColor_r7	= r7
	;; ==================

	srcPixelPre_r0	= r0
	ruInc_r0	= r0
	rvInc_r1	= r1
	srcPixel_r2	= r2
	bgPixel_r3	= r3
	dstPtr_r4	= r4
	fgTrans_r4	= r4
	bgPtr_r5	= r5
	pixelMask_r6	= r6
	temp_zero_r6	= r6
	bgTrans_r7	= r7
	fgTransPix_r7	= r7

	destBuffPtr_r8	= r8
	xyctl_r9	= r9
	const1dot24_r10	= r10

	srcPixel_v2	= v2

	tmp1_r8		= r8
	tmp2_r9		= r9
	tmp3_r10	= r10
	tmp4_r11	= r11
	
	fgPixelRGB_v3	= v3

	fgPixelRGB_v4	= v4
	fgPixelR_r16	= r16
	fgPixelG_r17	= r17
	fgPixelB_r18	= r18
	
	bgPixel_v3	= v3

	bgPixelRGB_v2	= v2	; reuse v2
	bgPixelR_r8	= r8
	bgPixelG_r9	= r9
	bgPixelB_r10	= r10

	bgPixelRGB_v3	= v3
	bgPixelR_r12	= r12
	bgPixelG_r13	= r13
	bgPixelB_r14	= r14
	bgPixelA_r15	= r15

	destPixelRGB_v3	= v3
	destPixelR_r12	= r12
	destPixelG_r13	= r13
	destPixelB_r14	= r14

	destPixelRGB_v4	= v4
	destPixelR_r16	= r16
	destPixelG_r17	= r17
	destPixelB_r18	= r18

	destPixel_v3	= v3
	destPixelY_r12	= r12
	destPixelCr_r13	= r13
	destPixelCb_r14	= r14

	destPixel_v4	= v4
	destPixelY_r16	= r16
	destPixelCr_r17	= r17
	destPixelCb_r18	= r18

	tmp1_r16	= r16
	tmp2_r17	= r17
	tmp3_r18	= r18
	tmp4_r19	= r19
	
	convYToFG_v5	= v5
	convCrToFG_v6	= v6
	convCbToFG_v7	= v7

	convYToBG_v5	= v5
	convCrToBG_v6	= v6
	convCbToBG_v7	= v7

	convToR_v5	= v5
	convToG_v6	= v6
	convToB_v7	= v7

	convToY_v5	= v5
	convToCr_v6	= v6
	convToCb_v7	= v7

	;; == SP_YAR11 ======
	fromYToY_v3	= v3
	fromCrToCr_v4	= v4
	fromCbToCb_v5	= v5
	srcPixel_v6	= v6
	dstPixelY_r28	= r28
	dstPixelCr_r29	= r29
	dstPixelCb_r30	= r30
	dstPixel_v7	= v7
	;; ==================
.endif