;;; ================================================================================================
;;; 
;;; Standard sprite renderer
;;;
;;; Transparency: NO
;;; Translucency: NO
;;; Tinting:      NO
;;; Bilerp:       NO
;;;
;;; pixg0 - inner lloop for esprite
;;; simplest case, pixel replicate with no xparency
;;;
;;; Num ticks:
;;;   Normal      - 2
;;;
;;; ================================================================================================

	.overlay pixgen0
	.origin pixgen

	.include "sp_def.i"
	
pixelType0:
	
.if (PERFMON_ENABLE == 1)
	ld_s	perfmonPixels+0,r0
	nop
	add	dma_len,r0
	st_s	r0,perfmonPixels+0
.endif

	;; Get inputs
	copy	inpBufPtr_r16,dstPtr_r4		; grab the parameters that were passed in
	
{	ld_s	(uv),pixSrc1_r0			; read first pixel
	dec	rc0				; pre-decrement
	addr	tosource[0],ru			; advance to next pixel...
}
	addr	tosource[2],rv			; ...continue advancing to next pixel

`next_pixel:
{	bra	c0eq,out			; are we done?
	ld_s	(uv),pixSrc2_r1			; get next pixel
	dec	rc0				; one more pixel done
	addr	tosource[0],ru			; advance to next pixel...
}
{	addr	tosource[2],rv			; ...continue advancing to next pixel
	bra	c0ne,`next_pixel		; branch back if not done
	st_s	pixSrc1_r0,(dstPtr_r4)		; store pixel in dest buffer
	add	#4,dstPtr_r4			; advance destination buffer pointer
}
{	bra	out				; fell through, must be finished
	ld_s	(uv),pixSrc1_r0			; get next pixel
	dec	rc0				; one more pixel done
	addr	tosource[0],ru			; advance to next pixel...
}
{	addr	tosource[2],rv			; ...continue advancing to next pixel
	st_s	pixSrc2_r1,(dstPtr_r4)		; store pixel in dest buffer
	add	#4,dstPtr_r4			; advance destination buffer pointer
}
	nop

endPixelType0: