	.segment local_ram

	.include "colormat.s"

srcPixel:
	.dc.s		$10808000

tint:
	.dc.s		$80008000
//	.dc.s		$80808000

dstPixel1:
	.ds.s		1
dstPixel2:
	.ds.s		1
	
	.segment	instruction_ram

start:
	st_s	#(4<<20),linpixctl
	
	ld_p	srcPixel,v0
	nop
	mv_s	#(1<<24),r3

	ld_v	convToR,v1
	ld_v	convToG,v2
	ld_v	convToB,v3

	dotp	v0,v1,>>#24,r16
	dotp	v0,v2,>>#24,r17
	dotp	v0,v3,>>#24,r18
	mv_s	#(1<<24),r19
	
	ld_v	convToY,v1
	ld_v	convToCr,v2
	ld_v	convToCb,v3

	dotp	v4,v1,>>#24,r20
	dotp	v4,v2,>>#24,r21
	dotp	v4,v3,>>#24,r22
	mv_s	#(1<<24),r23
	
	add	#(1<<21),r20
	add	#(1<<21),r21
	add	#(1<<21),r22

	st_p	v5,dstPixel1

	nop
	nop
	nop

	ld_p	tint,v0
	nop
	lsr	#5,r0
	lsr	#5,r1
	lsr	#5,r2
	mv_s	#0,r3
	
	ld_v	convToRFlip,v4
	ld_v	convToGFlip,v5
	ld_v	convToBFlip,v6
	ld_v	convToConstFlip,v7
	
	mul_p	v0,v4,>>#24,v4
	mul_p	v0,v5,>>#24,v5
	mul_p	v0,v6,>>#24,v6
	mul_p	v0,v7,>>#24,v7
	
	ld_v	convToY,v1
	nop
	dotp	v1,v4,>>#24,r8
	dotp	v1,v5,>>#24,r9
	dotp	v1,v6,>>#24,r10
	dotp	v1,v7,>>#24,r11
	add	#(1<<15),r8
	add	#(1<<15),r9
	add	#(1<<15),r10
	add	#(1<<15),r11
	st_v	v2,fromYToY

	ld_v	convToCr,v1
	nop
	dotp	v1,v4,>>#24,r8
	dotp	v1,v5,>>#24,r9
	dotp	v1,v6,>>#24,r10
	dotp	v1,v7,>>#24,r11
	add	#(1<<15),r8
	add	#(1<<15),r9
	add	#(1<<15),r10
	add	#(1<<15),r11
	st_v	v2,fromCrToCr

	ld_v	convToCb,v1
	nop
	dotp	v1,v4,>>#24,r8
	dotp	v1,v5,>>#24,r9
	dotp	v1,v6,>>#24,r10
	dotp	v1,v7,>>#24,r11
	add	#(1<<15),r8
	add	#(1<<15),r9
	add	#(1<<15),r10
	add	#(1<<15),r11
	st_v	v2,fromCbToCb

	
	ld_p	srcPixel,v0
	nop
	mv_s	#(1<<24),r3
	
	ld_v	fromYToY,v1
	ld_v	fromCrToCr,v2
	ld_v	fromCbToCb,v3

	dotp	v0,v1,>>#24,r16
	dotp	v0,v2,>>#24,r17
	dotp	v0,v3,>>#24,r18
	mv_s	#(1<<24),r19

	add	#(1<<21),r16
	add	#(1<<21),r17
	add	#(1<<21),r18

	st_p	v4,dstPixel2
	
forever:	
	jmp	forever
	nop
	nop

	